# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin, xbmcaddon, xbmcvfs
import sys, random, json
import urllib, urllib2, cookielib
import re, base64
from watched import *
from array import *
from htmlentitydefs import name2codepoint as n2cp
import htmlentitydefs
# new since v0.95
import urlresolver
# new since 1.3.0
from player import bsPlayer

thisPlugin = int(sys.argv[1])
print thisPlugin

addonInfo = xbmcaddon.Addon()
thumbUrl = addonInfo.getAddonInfo('path')+"/resources/img/"

# -- reading list from config --
hosterList = xbmcplugin.getSetting(thisPlugin,"hosterlist").lower()

urlHost = "https://bs.to/api/"
urlPics = "http://s.bs.to/img/cover/"

# --------------
# main functions
# --------------

def showContent(sortType):
	global thisPlugin
	print "[bs][showContent] started"
	seriesList = {}
	serie =[]
	picture = ""
	if sortType[0] == "A":
		# -- alphabetical order --
		data = json.loads(getUrl(urlHost+"series"))
		for d in data:
			serie = ["[B]"+d['series'].strip()+"[/B]",d['series'],d['id']]
			helper = ord(d['series'][0])
			if helper>90:
				helper = helper-32
			if (helper>64) and (helper<91):
				lKey = chr(helper).upper()
			else:
				lKey = "0"
			if lKey in seriesList:
				seriesList[lKey].append(serie)
			else:
				seriesList[lKey] = []
				seriesList[lKey].append(serie)
			
	if sortType[0] == "G":
		# -- sort by genre --
		data = getUrl(urlHost+"series:genre")
		content = json.loads(data)
		#print content
		for d,dv in content.iteritems():
			#print d
			#print dv
			if sortType[0] == "G":
				for ks in dv['series']:
					#print d
					serie = [d+" : [B]"+ks['name'].strip()+"[/B]",ks['name'],ks['id']]
					lKey = d
					if lKey in seriesList:
						seriesList[lKey].append(serie)
					else:
						seriesList[lKey] = []
						seriesList[lKey].append(serie)
	
	if len(sortType)==1:
		# -- if only A or G show list of series --
		addDirectoryItem(".sort by Alphabet", {"kindOf":0, "sortType": "A"})
		addDirectoryItem(".sort by Genre", {"kindOf":0, "sortType": "G"})
		addDirectoryItem("", {"kindOf":0, "sortType": "A"})
		for key in sorted(seriesList):
			picture = thumbUrl+key+".jpg"
			skey = key
			if key =="0":
				skey = "0-9 etc"
			addDirectoryItem("[B]"+skey+"[/B] (%d)" % len(seriesList[key]), {"kindOf":0, "sortType": sortType+key},picture)
	else:
		# -- show subset for A or G --
		# -- example AD shows all series with D
		# -- example GAnimation shows all Series in Animation
		sKey = sortType[1:]
		for s in sorted(seriesList[sKey], key=lambda f:f[0]):
			seriesName = s[0].encode("utf-8")
			picture = urlPics+str(s[2])+'.jpg'
			print picture
			# check if watched
			if readWatchedData(seriesName):
				seriesName = changeToWatched(seriesName)
			addDirectoryItem(seriesName, {"kindOf":1, "name": s[1].encode("utf-8"), "id":s[2],"doFav":"0"},picture)
	print "[bs][showContent] --- ok"	
	xbmcplugin.endOfDirectory(thisPlugin)

def showSeasons(name,id,doFav):
	global thisPlugin
	cover = urlPics+str(id)+'.jpg'
	print "[bs][showSeasons] started "+name
	print "[bs][showSeasons]--- series Data"
	print name
	addDirectoryItem("[B]."+name+"[/B]", {},cover)
	season = 0
	while True:
		season+=1
		data = json.loads(getUrl(urlHost+"series/"+str(id)+"/"+str(season)))
		print "[bs][showSeasons] read seasons"
		print data
		if data.has_key('error'):
			season-=1
			break
		if data.has_key('series'):
			addDirectoryItem("[B] Staffel"+str(season)+"[/B]", {"kindOf":2, "name":data['series']['series'].encode("utf-8"), "id":id, "season":season},cover)
	print "[bs][showSeasons] --- ok"	
	xbmcplugin.endOfDirectory(thisPlugin)

def showEpisodes(name,id,season):
	global thisPlugin
	cover = urlPics+str(id)+'.jpg'
	addDirectoryItem("[B]."+name+" Staffel "+str(season)+"[/B]", {},cover)
	print "[bs][showEpisodes] started with "+name
	data = json.loads(getUrl(urlHost+"series/"+str(id)+"/"+str(season)))
	print data['epi']
	for d in data['epi']:
		episodeName = "#"+str(d['epi'])
		if d.has_key('german'):
			episodeName += " "+d['german']
		if d.has_key('english'):
			if not d['english']=='':
				episodeName += " ("+d['english']+")"
		print episodeName.encode('utf-8')
		if readWatchedData(name):
			episodesWatched += 1
			episodeName = changeToWatched(episodeName)
		addDirectoryItem(episodeName, {"kindOf": 3, "name":data['series']['series'].encode("utf-8"), "id":id, "season":season, "episode":d['epi'],"episodename":episodeName.encode("utf-8")},cover)
	# if watched all episodes, mark Season
	#if episodesWatched == len(matchB):
	#	markParentEntry(name)
	print "[bs][showEpisodes] ok"	
	xbmcplugin.endOfDirectory(thisPlugin)

def showHosts(name, id, season,episode,episodeName):
	global thisPlugin
	matchCover = ""
	cover = urlPics+str(id)+'.jpg'
	addDirectoryItem("[B]."+name+" Staffel "+str(season)+" "+str(episode)+"[/B]", {},cover)
	addDirectoryItem("[B]."+episodeName+"[/B]", {},cover)
	data = json.loads(getUrl(urlHost+"series/"+str(id)+"/"+str(season)+"/"+str(episode)))
	print data['links']
	for d in data['links']:
		if d['hoster'].lower() in hosterList:
			showVideo(d['id'],data['series'].encode('utf-8'))
		addDirectoryItem("Host: "+d['hoster'], {"kindOf":4, "name": data['series'].encode("utf-8"),"vid":d['id']},matchCover)
	print "[bs][showHosts] ok"	
	xbmcplugin.endOfDirectory(thisPlugin)
	
def showVideo(vid, name):
	global thisPlugin
	print "[bs][showVideo] started on "+name+" - "+str(vid)
	data = json.loads(getUrl(urlHost+"watch/"+str(vid)))
	videoLink = urlresolver.resolve(data['fullurl']);
	print "[bs][showVideo] urlResolver returns - "
	print videoLink
	if videoLink:
		print "[bs][showVideo] urlResolver videoLink --"
		print videoLink
		item = xbmcgui.ListItem(path=videoLink)
		bsPlayer().playStream(videoLink, name.decode('latin-1'))
	else:
		addDirectoryItem("ERROR. Video deleted or urlResolver cant handle Host", {"urlV": "/"})
		xbmcplugin.endOfDirectory(thisPlugin)
		
#def showFavorites():
#	global thisPlugin
#	print "[bs][showFavorites] started"
#	favs.add_my_fav_directory()

# --------------
# --- helper ---
# --------------

def is_number(s):
    try:
        float(s)
        return True
    except ValueError:
        return False

def baseN(num,b,numerals="0123456789abcdefghijklmnopqrstuvwxyz"):
	return ((num == 0) and numerals[0]) or (baseN(num // b, b, numerals).lstrip(numerals[0]) + numerals[num % b])

def getUrl(url):
	try:
		req = urllib2.Request(url)
		req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
		response = urllib2.urlopen(req)
		return response.read()
		response.close()
	except:
		return False

def addDirectoryItem(name, parameters={},pic=""):
	iconpic = pic
	if pic == "":
		iconpic = "DefaultFolder.png"
	li = xbmcgui.ListItem(name,iconImage=iconpic, thumbnailImage=pic)
	u = sys.argv[0] + '?' + urllib.urlencode(parameters)
	return xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]), url=u, listitem=li, isFolder=True)

def addPlayableItem(name, parameters={},pic=""):
	iconpic = pic
	if pic == "":
		iconpic = "DefaultFolder.png"
	li = xbmcgui.ListItem(name,iconImage=iconpic, thumbnailImage=pic)
	li.setProperty("IsPlayable","true")
	u = sys.argv[0] + '?' + urllib.urlencode(parameters)
	return xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]), url=u, listitem=li, isFolder=False)

	
def parameters_string_to_dict(parameters):
    ''' Convert parameters encoded in a URL to a dict. '''
    paramDict = {}
    if parameters:
        paramPairs = parameters[1:].split("&")
        for paramsPair in paramPairs:
            paramSplits = paramsPair.split('=')
            if (len(paramSplits)) == 2:
                paramDict[paramSplits[0]] = paramSplits[1]
    return paramDict

def unescape(text):
    def fixup(m):
        text = m.group(0)
        if text[:2] == "&#":
            # character reference
            try:
                if text[:3] == "&#x":
                    return unichr(int(text[3:-1], 16))
                else:
                    return unichr(int(text[2:-1]))
            except ValueError:
                pass
        else:
            # named entity
            try:
                text = unichr(htmlentitydefs.name2codepoint[text[1:-1]])
            except KeyError:
                pass
        return text # leave as is
    return re.sub("&#?\w+;", fixup, unicode(text, "UTF-8"), re.UNICODE)
	
# since v1.1.0
def writePictureData(id,url):
	global cacheFile
	f = xbmcvfs.File(cacheFile)
	d = f.read()
	f.close()
	f = xbmcvfs.File(cacheFile, 'w')
	b = d+id+"<>"+url+"\n"
	result = f.write(b)
	print "[bs][writePictureData] write -> "+ id + " <> " +url
	f.close()
	return result

def readPictureData(id):
	global cacheFile
	f = xbmcvfs.File(cacheFile)
	b = f.read()
	f.close()
	cacheData = b.splitlines()
	for n in cacheData:
		splittedData = n.split("<>")
		if splittedData[0]==id:
			print "[bs][readPictureData] found cached "+id
			return splittedData[1]
	return False

# ----------------
# ----- main -----
# ----------------

params = parameters_string_to_dict(sys.argv[2])

#showFavs = str(params.get("showFavs",""))
kindOf = str(params.get("kindOf",""))
sortType = str(params.get("sortType", ""))
name = str(params.get("name", ""))
id = str(params.get("id", ""))
season = str(params.get("season", ""))
episode = str(params.get("episode", ""))
episodename = str(params.get("episodename", ""))
vid = str(params.get("vid", ""))

doFav = str(params.get("doFav",""))

print "[bs][init] show params"
print params

if not params.has_key('kindOf'):	# -- init start --
	kindOf = "0"
	sortType = "A"

if kindOf=="0":						# -- show Series --
	ok = showContent(sortType)
if kindOf=="1": 					# -- showSeasons --
	name = urllib.unquote(name)
	id = urllib.unquote(id)
	ok = showSeasons(name, id, doFav)
if kindOf=="2":						# -- showEpisodes --
	name = urllib.unquote(name)
	id = urllib.unquote(id)
	season = urllib.unquote(season)
	ok = showEpisodes(name, id, season)
if kindOf=="3":						# -- showHosts --
	name = urllib.unquote(name)
	id = urllib.unquote(id)
	season = urllib.unquote(season)
	episode = urllib.unquote(episode)
	episodename = urllib.unquote(episodename)
	ok = showHosts(name, id, season, episode, episodename)
if kindOf=="4":
	vid = urllib.unquote(vid)
	name = urllib.unquote(name)
	ok = showVideo(vid,name)
	